/* GCC */

#include <fstream>
#include <cmath>
#include <stdint.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NAME "race"

int recalc(int k);
void calculate();
void update(int , int);
void prepare(int n);
void read();
vector<int> add1, add2, temp, x;
int n, t1, a, t2, b, foo, bar;
int64_t res = 0;

int main()
{
    read();
    prepare(n);

    for (int i = 0; i < n; ++i)
    {
        int h = recalc(i);
        if (h > 0)
        {
            int total = (h + a - 1)/a;
            update(i, -total*a);
            if (i + t1 < n)
                update(i + t1, total*(a - b));
            if (i + t1 + t2 < n)
                update(i + t1 + t2, total*b);
            res += total;
        }
    }

    ofstream fout(NAME ".out");
    fout << res << endl;
    fout.close();

    return 0;
}

int recalc(int k)
{
    int s = 0;
    for (int i = (k/foo)*foo; i <= k; ++i)
        s += add1[i];
    for (int i = (k/bar)*foo; i < k/foo; ++i)
        s += add2[i];
    for (int i = 0; i < k/bar; ++i)
        s += temp[i];
    return s;
}


void calculate()
{
    foo = max(2, int(pow(add1.size(), 1.0 / 3.0)));
    bar = foo*foo;
    add2 = vector<int>((add1.size() + foo - 1)/foo);
    temp = vector<int>((add2.size() + foo - 1)/foo);
    for (int i = 0; i < (int) add1.size(); ++i)
    {
        add2[i/foo] += add1[i];
        temp[i/bar] += add1[i];
    }
}

void read()
{
    ifstream fin(NAME ".in");
    fin >> n >> t1>> t2 >> a >> b;
    x.resize(n);
    for (int i = 0; i < n; ++i)
        fin >> x[i];
    fin.close();
    if (a < b)
    {
        swap(a, b);
        swap(t1, t2);
        reverse(x.begin(), x.end());
    }
}


void update(int k, int delta)
{
    add1[k] += delta;
    add2[k/foo] += delta;
    temp[k/bar] += delta;
}

void prepare(int n)
{
    add1 = vector<int>(n);
    add1[0] = x[0];
    for (int i = 1; i < n; ++i)
        add1[i] = x[i] - x[i-1];
    calculate();

}

